'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _style = require('styled-jsx/style');

var _style2 = _interopRequireDefault(_style);

var _iconNg = require('icon-ng');

var _mobx = require('mobx');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _mobx.useStrict)(true);

var _store = (0, _mobx.observable)({
  ComponentState: []
});

var _size = 5;
while (_size--) {
  _store.ComponentState.push('closed');
}

var Sidenav = {
  _toggleButtonState: (0, _mobx.action)(function (id) {
    _store.ComponentState[id] = _store.ComponentState[id] == 'closed' ? 'open' : 'closed';
  }),
  setButtonStateOpen: (0, _mobx.action)(function (id) {
    _store.ComponentState[id] = 'open';
  }),
  Button: (0, _mobxReact.observer)(function (_ref) {
    var _ref$iconPosition = _ref.iconPosition,
        iconPosition = _ref$iconPosition === undefined ? 'left top' : _ref$iconPosition,
        _ref$menuPosition = _ref.menuPosition,
        menuPosition = _ref$menuPosition === undefined ? 'left' : _ref$menuPosition,
        _ref$iconOpen = _ref.iconOpen,
        iconOpen = _ref$iconOpen === undefined ? _react2.default.createElement(_iconNg.Hamburger, null) : _ref$iconOpen,
        _ref$iconClose = _ref.iconClose,
        iconClose = _ref$iconClose === undefined ? _react2.default.createElement(_iconNg.Close, null) : _ref$iconClose,
        _ref$id = _ref.id,
        id = _ref$id === undefined ? 0 : _ref$id,
        children = _ref.children;

    var icon = _store.ComponentState[id] == 'closed' ? iconOpen : iconClose;
    return _react2.default.createElement(
      'div',
      {
        'data-jsx': 2981382462
      },
      _react2.default.createElement(
        'div',
        { className: 'icon ' + iconPosition, onClick: function onClick() {
            return Sidenav._toggleButtonState(id);
          }, 'data-jsx': 2981382462
        },
        icon
      ),
      _react2.default.createElement(
        'div',
        { className: _store.ComponentState[id] + ' ' + menuPosition, 'data-jsx': 2981382462
        },
        children
      ),
      _react2.default.createElement(_style2.default, {
        styleId: 2981382462,
        css: '[data-jsx="2981382462"]{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.closed[data-jsx="2981382462"]{display:none}.open[data-jsx="2981382462"]{position:fixed;right:0px;top:0px;z-index:9998;background-color:seashell;padding-left:10px;height:100%;min-width:140px;width:20%}.icon[data-jsx="2981382462"]{margin:3px 10px;position:fixed;z-index:9999;cursor:pointer}.bottom[data-jsx="2981382462"]{bottom:20px}.left[data-jsx="2981382462"]{left:0px}.right[data-jsx="2981382462"]{right:0px}'
      })
    );
  }),
  Divider: function Divider() {
    return _react2.default.createElement(
      'div',
      {
        'data-jsx': 3994155439
      },
      _react2.default.createElement('hr', {
        'data-jsx': 3994155439
      }),
      _react2.default.createElement(_style2.default, {
        styleId: 3994155439,
        css: ''
      })
    );
  },
  Item: function Item(_ref2) {
    var children = _ref2.children;
    return _react2.default.createElement(
      'a',
      {
        'data-jsx': 858460443
      },
      children,
      _react2.default.createElement(_style2.default, {
        styleId: 858460443,
        css: '[data-jsx="858460443"]{padding:8px 8px 8px 30px;text-decoration:none;color:#818181;display:block;-webkit-transition:0.3s;transition:0.3s;cursor:pointer}[data-jsx="858460443"]:hover,[data-jsx="858460443"]:focus{color:#f1f1f1}'
      })
    );
  },
  Title: function Title(_ref3) {
    var children = _ref3.children;
    return _react2.default.createElement(
      'p',
      {
        'data-jsx': 2957648722
      },
      children,
      _react2.default.createElement(_style2.default, {
        styleId: 2957648722,
        css: '[data-jsx="2957648722"]{cursor:default;margin-top:60px;margin-left:10px;font-size:1.6em;font-weight:bold;text-transform:uppercase}'
      })
    );
  }
};

exports.default = Sidenav;