import { Close, Hamburger } from 'icon-ng'
import { action, observable, useStrict } from 'mobx'

import React from 'react'
import { observer } from 'mobx-react'

useStrict(true)

let _store = observable({
  ComponentState: []
})

let _size = 5
while (_size--) {
  _store.ComponentState.push('closed')
}

const Sidenav = {
  _toggleButtonState: action((id) => {
    _store.ComponentState[id] = _store.ComponentState[id] == 'closed' ? 'open' : 'closed'
  }),
  setButtonStateOpen: action((id) => {
    _store.ComponentState[id] = 'open'
  }),
  Button: observer(
    ({ iconPosition = 'left top', menuPosition = 'left', iconOpen = <Hamburger />, iconClose = <Close />, id = 0, children }) => {
      let icon = _store.ComponentState[id] == 'closed' ? iconOpen : iconClose
      return (
        <div>
          <div className={'icon ' + iconPosition} onClick={() => Sidenav._toggleButtonState(id)}>{icon}</div>
          <div className={_store.ComponentState[id] + ' ' + menuPosition}>{children}</div>
          <style jsx>{`
            user-select: none; 
            .closed {    
              display: none;} 
            .open {
              position: fixed;              
              right: 0px;
              top: 0px;
              z-index: 9998;            
              background-color: seashell;
              padding-left: 10px;
              height: 100%;                      
              min-width: 140px;      
              width: 20%;}
            .icon {
              margin: 3px 10px;
              position: fixed;                            
              z-index: 9999;                          
              cursor: pointer; }
            .bottom {
              bottom: 20px;}
            .left {
              left: 0px;}
            .right {
              right: 0px;}
        `}</style>

        </div>
      )
    }),
  Divider: () => {
    return (
      <div>
        <hr />
        <style jsx>{`
        `}</style>
      </div>
    )
  },
  Item: ({ children }) => (
    <a>{children}
      <style jsx>{`
          padding: 8px 8px 8px 30px;
          text-decoration: none;
          color: #818181;
          display: block;
          transition: 0.3s;
          cursor: pointer;              
          :hover, :focus {
              color: #f1f1f1;            
          }
        `}</style>
    </a >
  ),
  Title: ({ children }) => (
    <p>
      {children}
      <style jsx>{`
          cursor: default;
          margin-top: 60px;
          margin-left: 10px;
          font-size: 1.6em;        
          font-weight: bold;
          text-transform: uppercase;
        `}
      </style>
    </p>
  )
}

export default Sidenav